
//import java.util.*;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Zone {
  Pave[] paves; int no;
  
  Zone(int n,Pave... ps) { paves=ps; no=n; }
  
  void colorer(int c) { for (Pave p : paves()) p.colorer(c); }
  Pave[] paves() { return paves; }
  
  Zone suivante(boolean s) {
    if (s) {
      if (this==tco.z0) return tco.z5;
      if (this==tco.z1) return tco.z5;
      if (this==tco.z5) return tco.z4;
      if (this==tco.z4) return tco.z3;
      if (this==tco.z3) return tco.z2;
      if (this==tco.z2) if (tco.a0.directe()) return tco.z0; else return tco.z1;
    } else {
      if (this==tco.z0) return tco.z2;
      if (this==tco.z1) return tco.z2;
      if (this==tco.z5) if (tco.a1.directe()) return tco.z0; else return tco.z1;
      if (this==tco.z4) return tco.z5;
      if (this==tco.z3) return tco.z4;
      if (this==tco.z2) return tco.z3;
    }
    return null;
  }
}

class Aiguille {
  boolean etat=true;
  Pave pave;
  
  Aiguille(Pave p) { pave=p; }
  
  boolean directe() { return etat; }
  void manoeuvrer() { pave.manoeuvrer(); etat=!etat; }
}

class Signal {
  //boolean etat=true;
  Pave pave;
  int c; // couleur
  boolean sens=true; // false : sens pair   true : sens impair  Pave pave;
  
  Signal(Pave p,boolean s) { pave=p; sens=s; }
  void feu(int c) { pave.feu(c); this.c=c; }
  boolean ferme() { return c==COULEUR_ROUGE; } // !!! autres couleurs
  boolean sensImpair()  { return sens; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

final boolean PAIR=false,IMPAIR=true;

class Composants { 

Pave pz3c=new PaveArcN(IMPAIR,3).symetrie(),
     pz3b=new PaveDroitN(PAIR,5),
     pz3a=new PaveSignal(PAIR,COULEUR_JAUNE).retraitDroit(),
     
     pz4e=new PaveSignal(IMPAIR,COULEUR_JAUNE).rotation(2).retraitGauche(),
     pz4d=new PaveDroitN(PAIR,5),
     pz4c=new PaveArcN(PAIR,3),
     
     //pz4b=new PaveArcN(3).rotation(), // pose probleme avec les points
     // voie B
     pz2d=new PaveArc(PAIR).rotation(2).retraitDroit(),
     pz1a=new PaveSignal(PAIR,COULEUR_ROUGE).rotation(2).retraitGauche(),
     pz1b=new PaveDroitN(IMPAIR,2),
     pz1c=new PaveSignal(IMPAIR,COULEUR_ROUGE).retraitDroit(),
     pz5d=new PaveArc(IMPAIR).rotation(2).symetrie().retraitGauche(),
     // voie A
     pz3d=new PaveArcN(PAIR,3).rotation(2),
     pz3e=new PaveSignal(IMPAIR,COULEUR_ROUGE).retraitDroit(),
     pz2a=new PaveDroit(IMPAIR).retraitGauche(),
     pz2b=new PaveAiguille(IMPAIR),
     pz2c=new PaveDroit(IMPAIR).retraitDroit(),
     pz0a=new PaveSignal(PAIR,COULEUR_ROUGE).rotation(2).retraitGauche(),
     pz0b=new PaveDroitN(IMPAIR,2),
     pz0c=new PaveSignal(IMPAIR,COULEUR_ROUGE).retraitDroit(),
     pz5a=new PaveDroit(IMPAIR).retraitGauche(),
     pz5b=new PaveAiguille(PAIR).symetrie(),
     pz5c=new PaveDroit(IMPAIR).retraitDroit(),
     pz4a=new PaveSignal(PAIR,COULEUR_ROUGE).rotation(2).retraitGauche(),
     pz4b=new PaveArcN(IMPAIR,3).symetrie().rotation(2); // modifie

 //{xa,xb,ax,bx, ya,yb,ay,by};

  Pave xa=new PaveBouton("XA",0,true),
       xb=new PaveBouton("XB",1,true),
       ax=new PaveBouton("AX",2,true),
       bx=new PaveBouton("BX",3,true),
       
       ya=new PaveBouton("YA",4,true),
       yb=new PaveBouton("YB",5,true),
       ay=new PaveBouton("AY",6,true),
       by=new PaveBouton("BY",7,true);

  Pave[] itineraires={xa,xb,ax,bx, ya,yb,ay,by};
  
  Aiguille a0=new Aiguille(pz2b),
           a1=new Aiguille(pz5b);
           
 Aiguille[] aiguilles={a0,a1};
         
  Zone z0=new Zone(0,pz0a,pz0b,pz0c),
       z1=new Zone(1,pz1a,pz1b,pz1c),
       z2=new Z2(pz2a,pz2b,pz2c,pz2d),
       z3=new Z3Z4(pz3e,3,pz3a,pz3b,pz3c,pz3d,pz3e),
       z4=new Z3Z4(pz4a,4,pz4a,pz4b,pz4c,pz4d,pz4e),
       z5=new Z5(pz5a,pz5b,pz5c,pz5d);
  
  Zone[] zones={z0,z1,z2,z3,z4,z5};
       
  Signal s1=new Signal(pz4e,IMPAIR), // S1
         s2=new Signal(pz3a,PAIR), // S2
         
         c1=new Signal(pz3e,IMPAIR), // C1
         c2=new Signal(pz4a,PAIR), // C2
         c3=new Signal(pz0c,IMPAIR), // C3
         c4=new Signal(pz0a,PAIR), // C4
         c5=new Signal(pz1c,IMPAIR), // C5
         c6=new Signal(pz1a,PAIR); // C6
         
 Signal[] signaux={s1,s2}; Signal[] carres={c1,c2, c3,c4, c5,c6};
 
 //{xa,xb,ax,bx,ya,yb,ay,by};
 
 class Z3Z4 extends Zone {  // problemes avec occupation
    Pave pave;
    Z3Z4(Pave p,int n,Pave... ps) { super(n,ps); pave=p;  } 
    void colorer(int c) { 
    if (c==COULEUR_BLANCHE)     pave.colorer(c); 
    else for (Pave p : paves()) p.colorer(c); 
  }
 }

 class Z2 extends Zone {
    Z2(Pave... ps) { super(2,ps); } 
    
    Pave[] paves() { 
      if (a0.directe()) return new Pave[] {pz2a,pz2b,pz2c}; 
      else              return new Pave[] {pz2a,pz2b,pz2d}; 
    }
  }

  class Z5 extends Zone {
    Z5(Pave... ps) { super(5,ps); }
    
    Pave[] paves() { 
      if (a1.directe()) return new Pave[] {pz5a,pz5b,pz5c}; 
      else              return new Pave[] {pz5d,pz5b,pz5c}; 
    }
  }


}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////